using System;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Advanced.NET.Debugging.Chapter5
{
    class NativeEvent
    {
        private IntPtr nativeHandle;
        public IntPtr NativeHandle { get { return nativeHandle; } }

        public NativeEvent(string name)
        {
            nativeHandle = CreateEvent( IntPtr.Zero,
                                        false,
                                        true,
                                        name);

        }

        ~NativeEvent()
        {
            if(nativeHandle!=IntPtr.Zero)
            {
                CloseHandle(nativeHandle);
                nativeHandle=IntPtr.Zero;
            }
        }

        [DllImport("kernel32.dll")]
        static extern IntPtr CreateEvent(IntPtr attribs, bool manual, bool initial, string name);

        [DllImport("kernel32.dll")]
        static extern IntPtr CloseHandle(IntPtr handle);
    }
    
    
    class Finalize
    {
        static void Main(string[] args)
        {
            Finalize f = new Finalize();
            f.Run(args);
        }

        public void Run(string[] args)
        {

            NativeEvent nEvent = new NativeEvent("MyNewEvent");

            //
            // Use nEvent
            //

            nEvent = null;

            MessageBox.Show("Press any key to GC");
            
            GC.Collect();

            MessageBox.Show("Press any key to GC");

            GC.Collect();

            MessageBox.Show("Press any key to exit");
        }
    }
}
